/* ToolSupport.c generated by valac 0.56.18, the Vala compiler
 * generated from ToolSupport.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */
/* This file holds some abstractions around loading which ToolPlugin to use.*/
/* (i.e. whether to use Restic or Duplicity)*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "deja.h"
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DejaDupGetToolForBackendData DejaDupGetToolForBackendData;

struct _DejaDupGetToolForBackendData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DejaDupBackend* backend;
	DejaDupToolPlugin* result;
	GList* filenames;
	GList* _tmp0_;
	GCompareFunc _tmp1_;
	GList* _tmp2_;
	DejaDupToolPlugin* _tmp3_;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	DejaDupToolPlugin* _tmp6_;
	DejaDupToolPlugin* _tmp7_;
	DejaDupToolPlugin* _tmp8_;
	gchar** expected;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint expected_length1;
	gint _expected_size_;
	GList* _tmp15_;
	GList* filename_collection;
	GList* filename_it;
	gchar* _tmp16_;
	gchar* filename;
	gint i;
	gboolean _tmp17_;
	gint _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	const gchar* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gboolean found_all;
	gint _vala1_i;
	gboolean _tmp24_;
	gint _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar** _tmp27_;
	gint _tmp27__length1;
	const gchar* _tmp28_;
	DejaDupToolPlugin* _tmp29_;
	DejaDupToolPlugin* _tmp30_;
	DejaDupToolPlugin* _tmp31_;
	GError* _tmp32_;
	GError* _inner_error0_;
};

VALA_EXTERN DejaDupToolPlugin* deja_dup_restic_tool;
DejaDupToolPlugin* deja_dup_restic_tool = NULL;
VALA_EXTERN DejaDupToolPlugin* deja_dup_duplicity_tool;
DejaDupToolPlugin* deja_dup_duplicity_tool = NULL;

VALA_EXTERN gchar* deja_dup_unsupported_msg (const gchar* tool_name);
VALA_EXTERN DejaDupToolPlugin* deja_dup_make_borg_tool (GError** error);
VALA_EXTERN DejaDupToolPlugin* deja_dup_make_restic_tool (GError** error);
VALA_EXTERN DejaDupToolPlugin* deja_dup_make_duplicity_tool (void);
VALA_EXTERN DejaDupToolPlugin* deja_dup_make_tool (const gchar* tool_name,
                                       GError** error);
static void deja_dup_get_tool_for_backend_data_free (gpointer _data);
static gboolean deja_dup_get_tool_for_backend_co (DejaDupGetToolForBackendData* _data_);
static void deja_dup_get_tool_for_backend_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
deja_dup_unsupported_msg (const gchar* tool_name)
{
	gchar* _tmp0_;
	gchar* result;
#line 14 "../libdeja/ToolSupport.vala"
	g_return_val_if_fail (tool_name != NULL, NULL);
#line 17 "../libdeja/ToolSupport.vala"
	_tmp0_ = g_strdup_printf (_ ("%s backups are not supported in this release. Try using another storag" \
"e location."), tool_name);
#line 17 "../libdeja/ToolSupport.vala"
	result = _tmp0_;
#line 17 "../libdeja/ToolSupport.vala"
	return result;
#line 129 "ToolSupport.c"
}

DejaDupToolPlugin*
deja_dup_make_borg_tool (GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 30 "../libdeja/ToolSupport.vala"
	_tmp0_ = deja_dup_unsupported_msg ("Borg");
#line 30 "../libdeja/ToolSupport.vala"
	_tmp1_ = _tmp0_;
#line 30 "../libdeja/ToolSupport.vala"
	_tmp2_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_BAD_VALUE, _tmp1_);
#line 30 "../libdeja/ToolSupport.vala"
	_tmp3_ = _tmp2_;
#line 30 "../libdeja/ToolSupport.vala"
	_g_free0 (_tmp1_);
#line 30 "../libdeja/ToolSupport.vala"
	_inner_error0_ = _tmp3_;
#line 30 "../libdeja/ToolSupport.vala"
	if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 30 "../libdeja/ToolSupport.vala"
		g_propagate_error (error, _inner_error0_);
#line 30 "../libdeja/ToolSupport.vala"
		return NULL;
#line 158 "ToolSupport.c"
	} else {
#line 30 "../libdeja/ToolSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 30 "../libdeja/ToolSupport.vala"
		g_clear_error (&_inner_error0_);
#line 30 "../libdeja/ToolSupport.vala"
		return NULL;
#line 166 "ToolSupport.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../libdeja/ToolSupport.vala"
	return self ? g_object_ref (self) : NULL;
#line 175 "ToolSupport.c"
}

DejaDupToolPlugin*
deja_dup_make_restic_tool (GError** error)
{
	DejaDupToolPlugin* _tmp0_;
	DejaDupToolPlugin* _tmp2_;
	DejaDupToolPlugin* _tmp3_;
	DejaDupToolPlugin* result;
#line 40 "../libdeja/ToolSupport.vala"
	_tmp0_ = deja_dup_restic_tool;
#line 40 "../libdeja/ToolSupport.vala"
	if (_tmp0_ == NULL) {
#line 189 "ToolSupport.c"
		ResticPlugin* _tmp1_;
#line 41 "../libdeja/ToolSupport.vala"
		_tmp1_ = restic_plugin_new ();
#line 41 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (deja_dup_restic_tool);
#line 41 "../libdeja/ToolSupport.vala"
		deja_dup_restic_tool = (DejaDupToolPlugin*) _tmp1_;
#line 197 "ToolSupport.c"
	}
#line 42 "../libdeja/ToolSupport.vala"
	_tmp2_ = deja_dup_restic_tool;
#line 42 "../libdeja/ToolSupport.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 42 "../libdeja/ToolSupport.vala"
	result = _tmp3_;
#line 42 "../libdeja/ToolSupport.vala"
	return result;
#line 207 "ToolSupport.c"
}

DejaDupToolPlugin*
deja_dup_make_duplicity_tool (void)
{
	DejaDupToolPlugin* _tmp0_;
	DejaDupToolPlugin* _tmp2_;
	DejaDupToolPlugin* _tmp3_;
	DejaDupToolPlugin* result;
#line 51 "../libdeja/ToolSupport.vala"
	_tmp0_ = deja_dup_duplicity_tool;
#line 51 "../libdeja/ToolSupport.vala"
	if (_tmp0_ == NULL) {
#line 221 "ToolSupport.c"
		DuplicityPlugin* _tmp1_;
#line 52 "../libdeja/ToolSupport.vala"
		_tmp1_ = duplicity_plugin_new ();
#line 52 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (deja_dup_duplicity_tool);
#line 52 "../libdeja/ToolSupport.vala"
		deja_dup_duplicity_tool = (DejaDupToolPlugin*) _tmp1_;
#line 229 "ToolSupport.c"
	}
#line 53 "../libdeja/ToolSupport.vala"
	_tmp2_ = deja_dup_duplicity_tool;
#line 53 "../libdeja/ToolSupport.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 53 "../libdeja/ToolSupport.vala"
	result = _tmp3_;
#line 53 "../libdeja/ToolSupport.vala"
	return result;
#line 239 "ToolSupport.c"
}

DejaDupToolPlugin*
deja_dup_make_tool (const gchar* tool_name,
                    GError** error)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 58 "../libdeja/ToolSupport.vala"
	static GQuark _tmp1_label0 = 0;
#line 58 "../libdeja/ToolSupport.vala"
	static GQuark _tmp1_label1 = 0;
#line 58 "../libdeja/ToolSupport.vala"
	static GQuark _tmp1_label2 = 0;
#line 254 "ToolSupport.c"
	GError* _inner_error0_ = NULL;
	DejaDupToolPlugin* result;
#line 56 "../libdeja/ToolSupport.vala"
	g_return_val_if_fail (tool_name != NULL, NULL);
#line 58 "../libdeja/ToolSupport.vala"
	_tmp0_ = tool_name;
#line 58 "../libdeja/ToolSupport.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 58 "../libdeja/ToolSupport.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("borg")))) {
#line 58 "../libdeja/ToolSupport.vala"
		switch (0) {
#line 267 "ToolSupport.c"
			default:
			{
				DejaDupToolPlugin* _tmp3_ = NULL;
				DejaDupToolPlugin* _tmp4_;
				DejaDupToolPlugin* _tmp5_;
#line 61 "../libdeja/ToolSupport.vala"
				_tmp4_ = deja_dup_make_borg_tool (&_inner_error0_);
#line 61 "../libdeja/ToolSupport.vala"
				_tmp3_ = _tmp4_;
#line 61 "../libdeja/ToolSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../libdeja/ToolSupport.vala"
					if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 61 "../libdeja/ToolSupport.vala"
						g_propagate_error (error, _inner_error0_);
#line 61 "../libdeja/ToolSupport.vala"
						return NULL;
#line 285 "ToolSupport.c"
					} else {
#line 61 "../libdeja/ToolSupport.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../libdeja/ToolSupport.vala"
						g_clear_error (&_inner_error0_);
#line 61 "../libdeja/ToolSupport.vala"
						return NULL;
#line 293 "ToolSupport.c"
					}
				}
#line 61 "../libdeja/ToolSupport.vala"
				_tmp5_ = _tmp3_;
#line 61 "../libdeja/ToolSupport.vala"
				_tmp3_ = NULL;
#line 61 "../libdeja/ToolSupport.vala"
				result = _tmp5_;
#line 61 "../libdeja/ToolSupport.vala"
				_g_object_unref0 (_tmp3_);
#line 61 "../libdeja/ToolSupport.vala"
				return result;
#line 306 "ToolSupport.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("restic")))) {
#line 58 "../libdeja/ToolSupport.vala"
		switch (0) {
#line 312 "ToolSupport.c"
			default:
			{
				DejaDupToolPlugin* _tmp6_ = NULL;
				DejaDupToolPlugin* _tmp7_;
				DejaDupToolPlugin* _tmp8_;
#line 63 "../libdeja/ToolSupport.vala"
				_tmp7_ = deja_dup_make_restic_tool (&_inner_error0_);
#line 63 "../libdeja/ToolSupport.vala"
				_tmp6_ = _tmp7_;
#line 63 "../libdeja/ToolSupport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../libdeja/ToolSupport.vala"
					if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 63 "../libdeja/ToolSupport.vala"
						g_propagate_error (error, _inner_error0_);
#line 63 "../libdeja/ToolSupport.vala"
						return NULL;
#line 330 "ToolSupport.c"
					} else {
#line 63 "../libdeja/ToolSupport.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../libdeja/ToolSupport.vala"
						g_clear_error (&_inner_error0_);
#line 63 "../libdeja/ToolSupport.vala"
						return NULL;
#line 338 "ToolSupport.c"
					}
				}
#line 63 "../libdeja/ToolSupport.vala"
				_tmp8_ = _tmp6_;
#line 63 "../libdeja/ToolSupport.vala"
				_tmp6_ = NULL;
#line 63 "../libdeja/ToolSupport.vala"
				result = _tmp8_;
#line 63 "../libdeja/ToolSupport.vala"
				_g_object_unref0 (_tmp6_);
#line 63 "../libdeja/ToolSupport.vala"
				return result;
#line 351 "ToolSupport.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("auto")))) {
#line 58 "../libdeja/ToolSupport.vala"
		switch (0) {
#line 357 "ToolSupport.c"
			default:
			{
				DejaDupToolPlugin* _tmp9_;
#line 68 "../libdeja/ToolSupport.vala"
				_tmp9_ = deja_dup_make_duplicity_tool ();
#line 68 "../libdeja/ToolSupport.vala"
				result = _tmp9_;
#line 68 "../libdeja/ToolSupport.vala"
				return result;
#line 367 "ToolSupport.c"
			}
		}
	} else {
#line 58 "../libdeja/ToolSupport.vala"
		switch (0) {
#line 373 "ToolSupport.c"
			default:
			{
				DejaDupToolPlugin* _tmp10_;
#line 71 "../libdeja/ToolSupport.vala"
				_tmp10_ = deja_dup_make_duplicity_tool ();
#line 71 "../libdeja/ToolSupport.vala"
				result = _tmp10_;
#line 71 "../libdeja/ToolSupport.vala"
				return result;
#line 383 "ToolSupport.c"
			}
		}
	}
}

DejaDupToolPlugin*
deja_dup_get_default_tool (void)
{
	DejaDupFilteredSettings* settings = NULL;
	DejaDupFilteredSettings* _tmp0_;
	gchar* tool_name = NULL;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
	DejaDupToolPlugin* result;
#line 77 "../libdeja/ToolSupport.vala"
	_tmp0_ = deja_dup_get_settings (NULL);
#line 77 "../libdeja/ToolSupport.vala"
	settings = _tmp0_;
#line 78 "../libdeja/ToolSupport.vala"
	_tmp1_ = g_settings_get_string ((GSettings*) settings, DEJA_DUP_TOOL_WHEN_NEW_KEY);
#line 78 "../libdeja/ToolSupport.vala"
	tool_name = _tmp1_;
#line 406 "ToolSupport.c"
	{
		DejaDupToolPlugin* _tmp2_ = NULL;
		DejaDupToolPlugin* _tmp3_;
		DejaDupToolPlugin* _tmp4_;
#line 80 "../libdeja/ToolSupport.vala"
		_tmp3_ = deja_dup_make_tool (tool_name, &_inner_error0_);
#line 80 "../libdeja/ToolSupport.vala"
		_tmp2_ = _tmp3_;
#line 80 "../libdeja/ToolSupport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../libdeja/ToolSupport.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 419 "ToolSupport.c"
				goto __catch0_g_option_error;
			}
#line 80 "../libdeja/ToolSupport.vala"
			_g_free0 (tool_name);
#line 80 "../libdeja/ToolSupport.vala"
			_g_object_unref0 (settings);
#line 80 "../libdeja/ToolSupport.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "../libdeja/ToolSupport.vala"
			g_clear_error (&_inner_error0_);
#line 80 "../libdeja/ToolSupport.vala"
			return NULL;
#line 432 "ToolSupport.c"
		}
#line 80 "../libdeja/ToolSupport.vala"
		_tmp4_ = _tmp2_;
#line 80 "../libdeja/ToolSupport.vala"
		_tmp2_ = NULL;
#line 80 "../libdeja/ToolSupport.vala"
		result = _tmp4_;
#line 80 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (_tmp2_);
#line 80 "../libdeja/ToolSupport.vala"
		_g_free0 (tool_name);
#line 80 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (settings);
#line 80 "../libdeja/ToolSupport.vala"
		return result;
#line 448 "ToolSupport.c"
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		DejaDupToolPlugin* _tmp5_;
#line 79 "../libdeja/ToolSupport.vala"
		g_clear_error (&_inner_error0_);
#line 82 "../libdeja/ToolSupport.vala"
		_tmp5_ = deja_dup_make_duplicity_tool ();
#line 82 "../libdeja/ToolSupport.vala"
		result = _tmp5_;
#line 82 "../libdeja/ToolSupport.vala"
		_g_free0 (tool_name);
#line 82 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (settings);
#line 82 "../libdeja/ToolSupport.vala"
		return result;
#line 466 "ToolSupport.c"
	}
	__finally0:
#line 79 "../libdeja/ToolSupport.vala"
	_g_free0 (tool_name);
#line 79 "../libdeja/ToolSupport.vala"
	_g_object_unref0 (settings);
#line 79 "../libdeja/ToolSupport.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../libdeja/ToolSupport.vala"
	g_clear_error (&_inner_error0_);
#line 79 "../libdeja/ToolSupport.vala"
	return NULL;
#line 479 "ToolSupport.c"
}

static void
deja_dup_get_tool_for_backend_data_free (gpointer _data)
{
	DejaDupGetToolForBackendData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->backend);
	_g_object_unref0 (_data_->result);
	g_slice_free (DejaDupGetToolForBackendData, _data_);
}

void
deja_dup_get_tool_for_backend (DejaDupBackend* backend,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	DejaDupGetToolForBackendData* _data_;
	DejaDupBackend* _tmp0_;
	g_return_if_fail (backend != NULL);
	_data_ = g_slice_new0 (DejaDupGetToolForBackendData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, deja_dup_get_tool_for_backend_data_free);
	_tmp0_ = _g_object_ref0 (backend);
	_g_object_unref0 (_data_->backend);
	_data_->backend = _tmp0_;
	deja_dup_get_tool_for_backend_co (_data_);
}

DejaDupToolPlugin*
deja_dup_get_tool_for_backend_finish (GAsyncResult* _res_,
                                      GError** error)
{
	DejaDupToolPlugin* result;
	DejaDupGetToolForBackendData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
deja_dup_get_tool_for_backend_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	DejaDupGetToolForBackendData* _data_;
#line 90 "../libdeja/ToolSupport.vala"
	_data_ = _user_data_;
#line 90 "../libdeja/ToolSupport.vala"
	_data_->_source_object_ = source_object;
#line 90 "../libdeja/ToolSupport.vala"
	_data_->_res_ = _res_;
#line 90 "../libdeja/ToolSupport.vala"
	deja_dup_get_tool_for_backend_co (_data_);
#line 538 "ToolSupport.c"
}

static void
_g_free0_ (gpointer var)
{
#line 95 "../libdeja/ToolSupport.vala"
	var = (g_free (var), NULL);
#line 546 "ToolSupport.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 95 "../libdeja/ToolSupport.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 554 "ToolSupport.c"
}

static gboolean
deja_dup_get_tool_for_backend_co (DejaDupGetToolForBackendData* _data_)
{
#line 88 "../libdeja/ToolSupport.vala"
	switch (_data_->_state_) {
#line 88 "../libdeja/ToolSupport.vala"
		case 0:
#line 564 "ToolSupport.c"
		goto _state_0;
#line 88 "../libdeja/ToolSupport.vala"
		case 1:
#line 568 "ToolSupport.c"
		goto _state_1;
		default:
#line 88 "../libdeja/ToolSupport.vala"
		g_assert_not_reached ();
#line 573 "ToolSupport.c"
	}
	_state_0:
#line 90 "../libdeja/ToolSupport.vala"
	_data_->_state_ = 1;
#line 90 "../libdeja/ToolSupport.vala"
	deja_dup_backend_peek_at_files (_data_->backend, deja_dup_get_tool_for_backend_ready, _data_);
#line 90 "../libdeja/ToolSupport.vala"
	return FALSE;
#line 582 "ToolSupport.c"
	_state_1:
#line 90 "../libdeja/ToolSupport.vala"
	_data_->_tmp0_ = deja_dup_backend_peek_at_files_finish (_data_->backend, _data_->_res_);
#line 90 "../libdeja/ToolSupport.vala"
	_data_->filenames = _data_->_tmp0_;
#line 91 "../libdeja/ToolSupport.vala"
	_data_->_tmp1_ = ((GCompareFunc) g_strcmp0);
#line 91 "../libdeja/ToolSupport.vala"
	_data_->filenames = g_list_sort (_data_->filenames, _data_->_tmp1_);
#line 94 "../libdeja/ToolSupport.vala"
	_data_->_tmp2_ = _data_->filenames;
#line 94 "../libdeja/ToolSupport.vala"
	if (_data_->_tmp2_ == NULL) {
#line 95 "../libdeja/ToolSupport.vala"
		_data_->_tmp3_ = deja_dup_get_default_tool ();
#line 95 "../libdeja/ToolSupport.vala"
		_data_->result = _data_->_tmp3_;
#line 95 "../libdeja/ToolSupport.vala"
		(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 95 "../libdeja/ToolSupport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 95 "../libdeja/ToolSupport.vala"
		if (_data_->_state_ != 0) {
#line 95 "../libdeja/ToolSupport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 95 "../libdeja/ToolSupport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 610 "ToolSupport.c"
			}
		}
#line 95 "../libdeja/ToolSupport.vala"
		g_object_unref (_data_->_async_result);
#line 95 "../libdeja/ToolSupport.vala"
		return FALSE;
#line 617 "ToolSupport.c"
	}
#line 100 "../libdeja/ToolSupport.vala"
	_data_->_tmp4_ = _data_->filenames;
#line 100 "../libdeja/ToolSupport.vala"
	_data_->_tmp5_ = _data_->_tmp4_->data;
#line 100 "../libdeja/ToolSupport.vala"
	if (g_str_has_prefix ((const gchar*) _data_->_tmp5_, "duplicity-")) {
#line 101 "../libdeja/ToolSupport.vala"
		_data_->_tmp7_ = deja_dup_make_tool ("duplicity", &_data_->_inner_error0_);
#line 101 "../libdeja/ToolSupport.vala"
		_data_->_tmp6_ = _data_->_tmp7_;
#line 101 "../libdeja/ToolSupport.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 101 "../libdeja/ToolSupport.vala"
			if (_data_->_inner_error0_->domain == G_OPTION_ERROR) {
#line 101 "../libdeja/ToolSupport.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 101 "../libdeja/ToolSupport.vala"
				(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 101 "../libdeja/ToolSupport.vala"
				g_object_unref (_data_->_async_result);
#line 101 "../libdeja/ToolSupport.vala"
				return FALSE;
#line 641 "ToolSupport.c"
			} else {
#line 101 "../libdeja/ToolSupport.vala"
				(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 101 "../libdeja/ToolSupport.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 101 "../libdeja/ToolSupport.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 101 "../libdeja/ToolSupport.vala"
				g_object_unref (_data_->_async_result);
#line 101 "../libdeja/ToolSupport.vala"
				return FALSE;
#line 653 "ToolSupport.c"
			}
		}
#line 101 "../libdeja/ToolSupport.vala"
		_data_->_tmp8_ = _data_->_tmp6_;
#line 101 "../libdeja/ToolSupport.vala"
		_data_->_tmp6_ = NULL;
#line 101 "../libdeja/ToolSupport.vala"
		_data_->result = _data_->_tmp8_;
#line 101 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 101 "../libdeja/ToolSupport.vala"
		(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 101 "../libdeja/ToolSupport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 101 "../libdeja/ToolSupport.vala"
		if (_data_->_state_ != 0) {
#line 101 "../libdeja/ToolSupport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 101 "../libdeja/ToolSupport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 674 "ToolSupport.c"
			}
		}
#line 101 "../libdeja/ToolSupport.vala"
		g_object_unref (_data_->_async_result);
#line 101 "../libdeja/ToolSupport.vala"
		return FALSE;
#line 681 "ToolSupport.c"
	}
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp9_ = g_strdup ("config");
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp10_ = g_strdup ("data");
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp11_ = g_strdup ("index");
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp12_ = g_strdup ("keys");
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp13_ = g_strdup ("snapshots");
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp14_ = g_new0 (gchar*, 5 + 1);
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp14_[0] = _data_->_tmp9_;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp14_[1] = _data_->_tmp10_;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp14_[2] = _data_->_tmp11_;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp14_[3] = _data_->_tmp12_;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_tmp14_[4] = _data_->_tmp13_;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->expected = _data_->_tmp14_;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->expected_length1 = 5;
#line 107 "../libdeja/ToolSupport.vala"
	_data_->_expected_size_ = _data_->expected_length1;
#line 108 "../libdeja/ToolSupport.vala"
	_data_->_tmp15_ = _data_->filenames;
#line 713 "ToolSupport.c"
	{
#line 108 "../libdeja/ToolSupport.vala"
		_data_->filename_collection = _data_->_tmp15_;
#line 108 "../libdeja/ToolSupport.vala"
		for (_data_->filename_it = _data_->filename_collection; _data_->filename_it != NULL; _data_->filename_it = _data_->filename_it->next) {
#line 108 "../libdeja/ToolSupport.vala"
			_data_->_tmp16_ = g_strdup ((const gchar*) _data_->filename_it->data);
#line 108 "../libdeja/ToolSupport.vala"
			_data_->filename = _data_->_tmp16_;
#line 723 "ToolSupport.c"
			{
				{
#line 109 "../libdeja/ToolSupport.vala"
					_data_->i = 0;
#line 728 "ToolSupport.c"
					{
#line 109 "../libdeja/ToolSupport.vala"
						_data_->_tmp17_ = TRUE;
#line 109 "../libdeja/ToolSupport.vala"
						while (TRUE) {
#line 109 "../libdeja/ToolSupport.vala"
							if (!_data_->_tmp17_) {
#line 109 "../libdeja/ToolSupport.vala"
								_data_->_tmp18_ = _data_->i;
#line 109 "../libdeja/ToolSupport.vala"
								_data_->i = _data_->_tmp18_ + 1;
#line 740 "ToolSupport.c"
							}
#line 109 "../libdeja/ToolSupport.vala"
							_data_->_tmp17_ = FALSE;
#line 109 "../libdeja/ToolSupport.vala"
							_data_->_tmp19_ = _data_->expected;
#line 109 "../libdeja/ToolSupport.vala"
							_data_->_tmp19__length1 = _data_->expected_length1;
#line 109 "../libdeja/ToolSupport.vala"
							if (!(_data_->i < _data_->_tmp19__length1)) {
#line 109 "../libdeja/ToolSupport.vala"
								break;
#line 752 "ToolSupport.c"
							}
#line 110 "../libdeja/ToolSupport.vala"
							_data_->_tmp20_ = _data_->filename;
#line 110 "../libdeja/ToolSupport.vala"
							_data_->_tmp21_ = _data_->expected;
#line 110 "../libdeja/ToolSupport.vala"
							_data_->_tmp21__length1 = _data_->expected_length1;
#line 110 "../libdeja/ToolSupport.vala"
							_data_->_tmp22_ = _data_->_tmp21_[_data_->i];
#line 110 "../libdeja/ToolSupport.vala"
							if (g_strcmp0 (_data_->_tmp20_, _data_->_tmp22_) == 0) {
#line 111 "../libdeja/ToolSupport.vala"
								_data_->_tmp23_ = _data_->expected;
#line 111 "../libdeja/ToolSupport.vala"
								_data_->_tmp23__length1 = _data_->expected_length1;
#line 111 "../libdeja/ToolSupport.vala"
								_g_free0 (_data_->_tmp23_[_data_->i]);
#line 111 "../libdeja/ToolSupport.vala"
								_data_->_tmp23_[_data_->i] = NULL;
#line 112 "../libdeja/ToolSupport.vala"
								break;
#line 774 "ToolSupport.c"
							}
						}
					}
				}
#line 108 "../libdeja/ToolSupport.vala"
				_g_free0 (_data_->filename);
#line 781 "ToolSupport.c"
			}
		}
	}
#line 116 "../libdeja/ToolSupport.vala"
	_data_->found_all = TRUE;
#line 787 "ToolSupport.c"
	{
#line 117 "../libdeja/ToolSupport.vala"
		_data_->_vala1_i = 0;
#line 791 "ToolSupport.c"
		{
#line 117 "../libdeja/ToolSupport.vala"
			_data_->_tmp24_ = TRUE;
#line 117 "../libdeja/ToolSupport.vala"
			while (TRUE) {
#line 117 "../libdeja/ToolSupport.vala"
				if (!_data_->_tmp24_) {
#line 117 "../libdeja/ToolSupport.vala"
					_data_->_tmp25_ = _data_->_vala1_i;
#line 117 "../libdeja/ToolSupport.vala"
					_data_->_vala1_i = _data_->_tmp25_ + 1;
#line 803 "ToolSupport.c"
				}
#line 117 "../libdeja/ToolSupport.vala"
				_data_->_tmp24_ = FALSE;
#line 117 "../libdeja/ToolSupport.vala"
				_data_->_tmp26_ = _data_->expected;
#line 117 "../libdeja/ToolSupport.vala"
				_data_->_tmp26__length1 = _data_->expected_length1;
#line 117 "../libdeja/ToolSupport.vala"
				if (!(_data_->_vala1_i < _data_->_tmp26__length1)) {
#line 117 "../libdeja/ToolSupport.vala"
					break;
#line 815 "ToolSupport.c"
				}
#line 118 "../libdeja/ToolSupport.vala"
				_data_->_tmp27_ = _data_->expected;
#line 118 "../libdeja/ToolSupport.vala"
				_data_->_tmp27__length1 = _data_->expected_length1;
#line 118 "../libdeja/ToolSupport.vala"
				_data_->_tmp28_ = _data_->_tmp27_[_data_->_vala1_i];
#line 118 "../libdeja/ToolSupport.vala"
				if (_data_->_tmp28_ != NULL) {
#line 119 "../libdeja/ToolSupport.vala"
					_data_->found_all = FALSE;
#line 120 "../libdeja/ToolSupport.vala"
					break;
#line 829 "ToolSupport.c"
				}
			}
		}
	}
#line 123 "../libdeja/ToolSupport.vala"
	if (_data_->found_all) {
#line 124 "../libdeja/ToolSupport.vala"
		_data_->_tmp30_ = deja_dup_make_tool ("restic", &_data_->_inner_error0_);
#line 124 "../libdeja/ToolSupport.vala"
		_data_->_tmp29_ = _data_->_tmp30_;
#line 124 "../libdeja/ToolSupport.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 124 "../libdeja/ToolSupport.vala"
			if (_data_->_inner_error0_->domain == G_OPTION_ERROR) {
#line 124 "../libdeja/ToolSupport.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 124 "../libdeja/ToolSupport.vala"
				_data_->expected = (_vala_array_free (_data_->expected, _data_->expected_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../libdeja/ToolSupport.vala"
				(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 124 "../libdeja/ToolSupport.vala"
				g_object_unref (_data_->_async_result);
#line 124 "../libdeja/ToolSupport.vala"
				return FALSE;
#line 854 "ToolSupport.c"
			} else {
#line 124 "../libdeja/ToolSupport.vala"
				_data_->expected = (_vala_array_free (_data_->expected, _data_->expected_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../libdeja/ToolSupport.vala"
				(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 124 "../libdeja/ToolSupport.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 124 "../libdeja/ToolSupport.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 124 "../libdeja/ToolSupport.vala"
				g_object_unref (_data_->_async_result);
#line 124 "../libdeja/ToolSupport.vala"
				return FALSE;
#line 868 "ToolSupport.c"
			}
		}
#line 124 "../libdeja/ToolSupport.vala"
		_data_->_tmp31_ = _data_->_tmp29_;
#line 124 "../libdeja/ToolSupport.vala"
		_data_->_tmp29_ = NULL;
#line 124 "../libdeja/ToolSupport.vala"
		_data_->result = _data_->_tmp31_;
#line 124 "../libdeja/ToolSupport.vala"
		_g_object_unref0 (_data_->_tmp29_);
#line 124 "../libdeja/ToolSupport.vala"
		_data_->expected = (_vala_array_free (_data_->expected, _data_->expected_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../libdeja/ToolSupport.vala"
		(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 124 "../libdeja/ToolSupport.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 124 "../libdeja/ToolSupport.vala"
		if (_data_->_state_ != 0) {
#line 124 "../libdeja/ToolSupport.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 124 "../libdeja/ToolSupport.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 891 "ToolSupport.c"
			}
		}
#line 124 "../libdeja/ToolSupport.vala"
		g_object_unref (_data_->_async_result);
#line 124 "../libdeja/ToolSupport.vala"
		return FALSE;
#line 898 "ToolSupport.c"
	}
#line 127 "../libdeja/ToolSupport.vala"
	_data_->_tmp32_ = g_error_new_literal (G_OPTION_ERROR, G_OPTION_ERROR_FAILED, _ ("Unrecognized files in storage location. Choose an empty folder instead" \
"."));
#line 127 "../libdeja/ToolSupport.vala"
	_data_->_inner_error0_ = _data_->_tmp32_;
#line 127 "../libdeja/ToolSupport.vala"
	if (_data_->_inner_error0_->domain == G_OPTION_ERROR) {
#line 127 "../libdeja/ToolSupport.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 127 "../libdeja/ToolSupport.vala"
		_data_->expected = (_vala_array_free (_data_->expected, _data_->expected_length1, (GDestroyNotify) g_free), NULL);
#line 127 "../libdeja/ToolSupport.vala"
		(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 127 "../libdeja/ToolSupport.vala"
		g_object_unref (_data_->_async_result);
#line 127 "../libdeja/ToolSupport.vala"
		return FALSE;
#line 916 "ToolSupport.c"
	} else {
#line 127 "../libdeja/ToolSupport.vala"
		_data_->expected = (_vala_array_free (_data_->expected, _data_->expected_length1, (GDestroyNotify) g_free), NULL);
#line 127 "../libdeja/ToolSupport.vala"
		(_data_->filenames == NULL) ? NULL : (_data_->filenames = (_g_list_free__g_free0_ (_data_->filenames), NULL));
#line 127 "../libdeja/ToolSupport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 127 "../libdeja/ToolSupport.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 127 "../libdeja/ToolSupport.vala"
		g_object_unref (_data_->_async_result);
#line 127 "../libdeja/ToolSupport.vala"
		return FALSE;
#line 930 "ToolSupport.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

